#include <iostream>
#include <string>
#include <sstream>

#include "datum.h"

using namespace std;

const int POCET_MESICU = 12;
const string nazev[] = {"Den"s, "Mesic"s, "Rok"s};
const string jmeno_mesice[]{ "", "ledna", "února", "března",
           "dubna", "května", "června", "července", "srpna", 
           "září", "října", "listopadu", "prosince" };

int pocet_dnu_do_zacatku[POCET_MESICU + 1]{};

const int pocet_dnu_v_mesici[POCET_MESICU + 1] = {0, 31, 28, 31, 30, 31, 
                     30, 31, 31, 30, 31, 30, 31};

void priprava()
{
    for(int i = 1; i <= POCET_MESICU; i++)
    {
        pocet_dnu_do_zacatku[i] = pocet_dnu_do_zacatku[i-1] + pocet_dnu_v_mesici[i-1];
    }
}

bool prestupny(int rok)
{
    return ((rok % 4 == 0) && (rok % 100 != 0)) || (rok % 400 == 0);
}

datum zadost()
{
    cout << "Zadej prosím datum." << endl;
    int zadano[3];
    for(int i = den; i <= rok; i++)
    {
        cout << nazev[i] << ": ";
        cin >> zadano[i];
    }
    return datum{zadano[den], zadano[mesic], zadano[rok]};
}

int cislo_dne(datum dnes)
{
    int vysledek = pocet_dnu_do_zacatku[dnes.mesic] + dnes.den;
    if(prestupny(dnes.rok))
    {
        vysledek++;
    }
    return vysledek;
}

void vypis_data(datum dnes)
{
    cout << dnes.den << ". " << dnes.mesic << ". " << dnes.rok;
}

string datum_na_retezec(datum dnes, format_data format)
{
    ostringstream vystup;
    vystup << dnes.den << ". ";
    vystup << ((format == kratky || format == stredni) 
               ? to_string(dnes.mesic) + ". "s 
               : jmeno_mesice[dnes.mesic] + " "s); 
    vystup << ((format == kratky) ? dnes.rok % 1000 : dnes.rok);
    return vystup.str();
}

bool kontrola(datum dnes)
{
    if((dnes.mesic <= 0) || (dnes.mesic > POCET_MESICU))
    {
        return false;
    }
    if((dnes.den > 0) && (dnes.den <= pocet_dnu_v_mesici[dnes.mesic]))
    {
        return true;
    }
    if(dnes.den == 29 && dnes.mesic == 2 && prestupny(dnes.rok))
    {
        return true;
    }
    return false;
}

datum zitra(datum dnes)
{
    dnes.den++;
    if(kontrola(dnes))
    {
        return dnes;
    }
    dnes.den = 1;
    dnes.mesic++;
    if(kontrola(dnes))
    {
        return dnes;
    }
    dnes.mesic = 1;
    dnes.rok++;
    return dnes;
}
